function PrintSumStats(SumStats,VarLabels,FileName)
if nargin<3
  FileName='output/sumstats.tex';
end

if exist(FileName,'file')
  eval(['!rm ',FileName]);
end

diary(FileName);
disp('\documentclass[12pt]{article}');
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%');
disp('\usepackage{amsfonts}');
disp('\usepackage{mitpress}');
disp('');
disp('%TCIDATA{OutputFilter=LATEX.DLL}');
disp('%TCIDATA{Version=5.50.0.2890}');
disp('%TCIDATA{<META NAME="SaveForMode" CONTENT="1">}');
disp('%TCIDATA{BibliographyScheme=Manual}');
disp('%TCIDATA{Created=Monday, October 13, 2008 11:48:32}');
disp('%TCIDATA{LastRevised=Monday, October 13, 2008 11:51:43}');
disp('%TCIDATA{<META NAME="GraphicsSave" CONTENT="32">}');
disp('%TCIDATA{<META NAME="DocumentShell" CONTENT="Articles\SW\A Simple MIT Press Article">}');
disp('%TCIDATA{CSTFile=LaTeX Article (bright).cst}');
disp('');
disp('\newtheorem{theorem}{Theorem}');
disp('\newtheorem{acknowledgement}[theorem]{Acknowledgement}');
disp('\newtheorem{algorithm}[theorem]{Algorithm}');
disp('\newtheorem{axiom}[theorem]{Axiom}');
disp('\newtheorem{case}[theorem]{Case}');
disp('\newtheorem{claim}[theorem]{Claim}');
disp('\newtheorem{conclusion}[theorem]{Conclusion}');
disp('\newtheorem{condition}[theorem]{Condition}');
disp('\newtheorem{conjecture}[theorem]{Conjecture}');
disp('\newtheorem{corollary}[theorem]{Corollary}');
disp('\newtheorem{criterion}[theorem]{Criterion}');
disp('\newtheorem{definition}[theorem]{Definition}');
disp('\newtheorem{example}[theorem]{Example}');
disp('\newtheorem{exercise}[theorem]{Exercise}');
disp('\newtheorem{lemma}[theorem]{Lemma}');
disp('\newtheorem{notation}[theorem]{Notation}');
disp('\newtheorem{problem}[theorem]{Problem}');
disp('\newtheorem{proposition}[theorem]{Proposition}');
disp('\newtheorem{remark}[theorem]{Remark}');
disp('\newtheorem{solution}[theorem]{Solution}');
disp('\newtheorem{summary}[theorem]{Summary}');
disp('\newenvironment{proof}[1][Proof]{\noindent\textbf{#1.} }{\ \rule{0.5em}{0.5em}}');
disp('\newdimen\dummy');
disp('\dummy=\oddsidemargin');
disp('\addtolength{\dummy}{72pt}');
disp('\marginparwidth=.5\dummy');
disp('\marginparsep=.1\dummy');
disp('');
disp('\input{tcilatex}');
disp('');
disp('\begin{document}');
disp('');
disp('\title{Summary Statistics}');
disp('\author{L. Nesheim \\');
disp('%EndAName');
disp('CEMMAP}');
disp('\maketitle');
disp('\begin{tabular}{|c|c|c|c|c|c|}');
disp('\hline');
disp('& Mean & Variance & Min & Max & N \\ \hline');

[n,k]=size(SumStats);
for i=1:n
  disp([VarLabels{i},' & ',           ...
        num2str(SumStats(i,1)),' & ', ...
        num2str(SumStats(i,2)),' & ', ...
        num2str(SumStats(i,3)),' & ', ...
        num2str(SumStats(i,4)),' & ', ...
        num2str(SumStats(i,5)),' \\ \hline']);
end
disp('\end{tabular}');
disp('');
disp('\end{document}');
diary off;