function SubIndex=RemoveIndex(FullIndex,IndexToRemove)
% function SubIndex=RemoveIndex(FullIndex,IndexToRemove)
% Remove IndexToRemove from FullIndex to create SubIndex.
% 
% SubIndex       = (nSubIndex x 1) SubIndex after removing IndexToRemove)
% FullIndex      = (nFree0 x 1)    index numbers of free parameters 
%                                  (before removing iNotIdentified)
% IndexToRemove  = (nRemove x 1)   indexes of parameters that are not identified in current data
%                                  because they correspond to fixed effect options that are never chosen.
% Revision history
% 14sep2009 LPN created function.

nRemove=length(IndexToRemove);
nFull=length(FullIndex);

YesIndex=ones(nFull,1);

for i1=1:nRemove
  YesIndex = FullIndex~=IndexToRemove(i1) & YesIndex==1;
end

SubIndex=FullIndex(YesIndex==1);