function iFree=CreateIFreeRank(RCDim,RCRank)
% Create vector of integers numbering free elements of iFree.COffDiag
%  size(COffDiag,1) = iFree0
%  elements of COffDiag corresponding to columns > RCRank are not free
%  elements of COffDiag corresponding to zero elements of CDiag are fixed
iFree0=(1:RCDim*(RCDim-1)/2)';
C=zeros(RCDim,RCDim);
for i1=2:RCDim
  C(i1,1:i1-1) = iFree0((i1-1)*(i1-2)/2+(1:i1-1)');
end
C=reshape(C(:,1:RCRank)',[RCDim*RCRank,1]);
iFree=C(C>0);