function [beta2,C,CDiag,COffDiag] = ...
    MapFreeToStructural(xFree2,iFree2,beta2,CDiag,COffDiag,RCDim)
% Map free parameters to structural parameters
%
%
% Revision History
% 2017MAR18  Cleaned version for publication.

% Vector of utility coefficients
%    xFree2    free parameters
%    beta2     structural utility parameters
%    iFree2    indexes used to map xFree2 to beta2 and C
if ~isempty(iFree2.beta{1})
  beta2(iFree2.beta{1})=xFree2(iFree2.beta{2});		
end

% Diagonal elements of C = chol(sig) where sig is covariance matrix of 
% random coefficients
if ~isempty(iFree2.CDiag{1})
  CDiag(iFree2.CDiag{1})=xFree2(iFree2.CDiag{2});
end

% OffDiagonal elements of C
if ~isempty(iFree2.COffDiag{1})
  COffDiag(iFree2.COffDiag{1}) = xFree2(iFree2.COffDiag{2});    
end

C=diag(CDiag);
for i1=2:RCDim
  C(i1,1:i1-1) = COffDiag((i1-1)*(i1-2)/2+(1:i1-1)');
end