function numerator = like3grad(i1,dv1,t1,iMax,prob0,Nodes,e, ...
                               DeltaX,DeltaZ, ...
                               iFree,iGrad,RCDim,RCRank,noptions,nT,nHH, ...
                               nFreeBeta,nFree,LogNormalFlag,LogNormalIndex)

numerator=zeros(nHH,nFree);

% Sum over options in choice set of dv1.*DeltaX, given current random coefficient shock
    % size(dv1) = (noptions*nT*nHH x 1)
    % size(t2) = (noptions*nHH x nFreeBeta)
    
% size(t2) = (J x nT x nHH)
% size(t2) = (noptions x nT x nHH)
% t2 = repmat(reshape(probT(:,:,i1),[1 nT nHH]),[noptions 1 1]);
% t2 = prob(j,t,:)
t2=reshape(dv1,[noptions nT nHH]) ...
   ./ repmat( reshape(t1,[1 nT nHH]),[noptions 1 1]);
    
iMax1 = kron(iMax,ones(noptions,1));
% size(xMax) = (nHH x kx)
xMax  = DeltaX(iMax1,iFree.beta{1});
%size(t3) = (nT x nHH x nFreeBeta)
t3 = -reshape(full(xMax((1:noptions:noptions*nT*nHH)',:)),[nT nHH nFreeBeta]) ...
     - squeeze(sum(repmat(t2,[1 1 1 nFreeBeta]) ...
                   .*reshape(full(DeltaX(:,iFree.beta{1}) ...
                                  -xMax), ...
                             [noptions nT nHH nFreeBeta]),1)); 
numerator(:,iFree.beta{2}) = repmat(squeeze(prob0),[1 nFreeBeta]).*squeeze(sum(t3,1));
    
for j1=1:RCDim
  if j1<=RCRank
    % Gradient w.r.t. C(j1,j1)
    if any(iFree.CDiag{1}==j1)
      t4 = Nodes(j1)*squeeze(sum(t2.*reshape(full(DeltaZ(:,j1)),[noptions nT nHH]),1));
      if LogNormalFlag==1 && any(j1==LogNormalIndex)
        t4 = t4*e(j1);    
      end
      numerator(:,iGrad.c{j1,j1})=-prob0.*sum(t4,1).';
    end
  end
      
  for j2=1:j1-1
     if j2<=RCRank
       % Gradient w.r.t. c(j1,j2)
       index = (j1-1)*(j1-2)/2+j2;
       if any(iFree.COffDiag{1}==index)
         %eval(['t3 = DeltaZ.z',int2str(j1),'(:,i1);']);
         t4 = Nodes(j2)*squeeze(sum(t2.*reshape(full(DeltaZ(:,j1)), ...
                                                [noptions nT nHH]),1));
         if LogNormalFlag==1 && any(j1==LogNormalIndex)
           t4 = t4*e(j1);      
         end
         numerator(:,iGrad.c{j1,j2})=-prob0.*sum(t4,1).';
       end % if any(iFree.COffDiag)
     end % if j2<=RCRank
  end   % for j2=1:j1-1
end     % for j1=1:RCRank
