
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Results
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear
path='C:/GriffithNesheimOConnell.2017.QE';
in=fullfile(path,'MatLab_files/Estimation');
cubic='Nonlinear';
linear='Linear';
pref='Prefshift';
approx='Linearized';
log='Log';
logcub='Logcubic';

out=fullfile(path,'Stata_files/MOut');

%%%Elasticities

%Nonlinear

mout=fullfile(out,'melas_cubic.raw');
oout=fullfile(out,'oelas_cubic.raw');

inf=fullfile(in,cubic,'V130_Elas.mat');
load(inf);
 
[T,H]=size(HHShare);

WS=HHShare.*HHWeights;                %T(s)xnHH
WS=WS./repmat(sum(WS,2),[1 H]);       %T(s)xnHH
WS=repmat(WS,[1 1 T]);                %T(s)xnHHxT(p)
WS=permute(WS,[3 1 2]);               %T(p)xT(s)xnHH

WElas=sum(HHElas.*WS,3);              %T(p)xT(s)
save(mout,'WElas','-ascii','-double','-tabs'); 

OElas=zeros(H*T,1);                   %TxnHH
for i=1:H
    OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
end

HHCode=kron(SortedHHCode,ones(T,1));
ProdCode=repmat(SortedProductCodeRaw,[H 1]);

Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
save(oout,'Elasdata','-ascii','-double','-tabs'); 

%Linear

mout=fullfile(out,'melas_linear.raw');
oout=fullfile(out,'oelas_linear.raw');

inf=fullfile(in,linear,'V131_Elas.mat');
load(inf);

[T,H]=size(HHShare);

WS=HHShare.*HHWeights;                %T(s)xnHH
WS=WS./repmat(sum(WS,2),[1 H]);       %T(s)xnHH
WS=repmat(WS,[1 1 T]);                %T(s)xnHHxT(p)
WS=permute(WS,[3 1 2]);               %T(p)xT(s)xnHH

WElas=sum(HHElas.*WS,3);              %T(p)xT(s)
save(mout,'WElas','-ascii','-double','-tabs'); 

OElas=zeros(H*T,1);                   %TxnHH
for i=1:H
    OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
end

HHCode=kron(SortedHHCode,ones(T,1));
ProdCode=repmat(SortedProductCodeRaw,[H 1]);

Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
save(oout,'Elasdata','-ascii','-double','-tabs'); 

%Preference shifter

mout=fullfile(out,'melas_prefshift.raw');
oout=fullfile(out,'oelas_prefshift.raw');

inf=fullfile(in,pref,'V132_Elas.mat');
load(inf);

[T,H]=size(HHShare);

WS=HHShare.*HHWeights;                %T(s)xnHH
WS=WS./repmat(sum(WS,2),[1 H]);       %T(s)xnHH
WS=repmat(WS,[1 1 T]);                %T(s)xnHHxT(p)
WS=permute(WS,[3 1 2]);               %T(p)xT(s)xnHH

WElas=sum(HHElas.*WS,3);              %T(p)xT(s)
save(mout,'WElas','-ascii','-double','-tabs'); 

OElas=zeros(H*T,1);                   %TxnHH
for i=1:H
    OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
end

HHCode=kron(SortedHHCode,ones(T,1));
ProdCode=repmat(SortedProductCodeRaw,[H 1]);

Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
save(oout,'Elasdata','-ascii','-double','-tabs'); 

%Linearized

mout=fullfile(out,'melas_linearized.raw');
oout=fullfile(out,'oelas_linearized.raw');

inf=fullfile(in,approx,'V133_Elas.mat');
load(inf);

[T,H]=size(HHShare);

WS=HHShare.*HHWeights;                %T(s)xnHH
WS=WS./repmat(sum(WS,2),[1 H]);       %T(s)xnHH
WS=repmat(WS,[1 1 T]);                %T(s)xnHHxT(p)
WS=permute(WS,[3 1 2]);               %T(p)xT(s)xnHH

WElas=sum(HHElas.*WS,3);              %T(p)xT(s)
save(mout,'WElas','-ascii','-double','-tabs'); 

OElas=zeros(H*T,1);                   %TxnHH
for i=1:H
    OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
end

HHCode=kron(SortedHHCode,ones(T,1));
ProdCode=repmat(SortedProductCodeRaw,[H 1]);

Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
save(oout,'Elasdata','-ascii','-double','-tabs'); 

%Log

mout=fullfile(out,'melas_log.raw');
oout=fullfile(out,'oelas_log.raw');

inf=fullfile(in,log,'V134_Elas.mat');
load(inf);

[T,H]=size(HHShare);

WS=HHShare.*HHWeights;                %T(s)xnHH
WS=WS./repmat(sum(WS,2),[1 H]);       %T(s)xnHH
WS=repmat(WS,[1 1 T]);                %T(s)xnHHxT(p)
WS=permute(WS,[3 1 2]);               %T(p)xT(s)xnHH

WElas=sum(HHElas.*WS,3);              %T(p)xT(s)
save(mout,'WElas','-ascii','-double','-tabs'); 

OElas=zeros(H*T,1);                   %TxnHH
for i=1:H
    OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
end

HHCode=kron(SortedHHCode,ones(T,1));
ProdCode=repmat(SortedProductCodeRaw,[H 1]);

Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
save(oout,'Elasdata','-ascii','-double','-tabs'); 

%Log-cubic

mout=fullfile(out,'melas_logcubic.raw');
oout=fullfile(out,'oelas_logcubic.raw');

inf=fullfile(in,logcub,'V136_Elas.mat');
load(inf);

[T,H]=size(HHShare);

WS=HHShare.*HHWeights;                %T(s)xnHH
WS=WS./repmat(sum(WS,2),[1 H]);       %T(s)xnHH
WS=repmat(WS,[1 1 T]);                %T(s)xnHHxT(p)
WS=permute(WS,[3 1 2]);               %T(p)xT(s)xnHH

WElas=sum(HHElas.*WS,3);              %T(p)xT(s)
save(mout,'WElas','-ascii','-double','-tabs'); 

OElas=zeros(H*T,1);                   %TxnHH
for i=1:H
    OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
end

HHCode=kron(SortedHHCode,ones(T,1));
ProdCode=repmat(SortedProductCodeRaw,[H 1]);

Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
save(oout,'Elasdata','-ascii','-double','-tabs'); 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Confidence bands
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%Elasticities

%Cubic

for j=1:100

    J=int2str(j);
    inf=fullfile(in,cubic,['bootstrap\elasticity',J]);
    load(inf);

    [T,H]=size(HHShare);

    OElas=zeros(H*T,1);                   %TxnHH
    for i=1:H
        OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
    end

    HHCode=kron(SortedHHCode,ones(T,1));
    ProdCode=repmat(SortedProductCodeRaw,[H 1]);

    Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
    oout=fullfile(out,'Elasticities\Nonlinear',['elasticity',J,'.raw']);
    save(oout,'Elasdata','-ascii','-double','-tabs'); 
end

%Linear

for j=1:100

    J=int2str(j);
    inf=fullfile(in,linear,['bootstrap\elasticity',J]);
    load(inf);

    [T,H]=size(HHShare);

    OElas=zeros(H*T,1);                   %TxnHH
    for i=1:H
        OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
    end

    HHCode=kron(SortedHHCode,ones(T,1));
    ProdCode=repmat(SortedProductCodeRaw,[H 1]);

    Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
    oout=fullfile(out,'Elasticities\Linear',['elasticity',J,'.raw']);
    save(oout,'Elasdata','-ascii','-double','-tabs'); 
end

%Preference shifter

for j=1:100

    J=int2str(j);
    inf=fullfile(in,pref,['bootstrap\elasticity',J]);
    load(inf);

    [T,H]=size(HHShare);

    OElas=zeros(H*T,1);                   %TxnHH
    for i=1:H
        OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
    end

    HHCode=kron(SortedHHCode,ones(T,1));
    ProdCode=repmat(SortedProductCodeRaw,[H 1]);

    Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
    oout=fullfile(out,'Elasticities\Prefshift',['elasticity',J,'.raw']);
    save(oout,'Elasdata','-ascii','-double','-tabs'); 
end

%Linearized

for j=1:100

    J=int2str(j);
    inf=fullfile(in,approx,['bootstrap\elasticity',J]);
    load(inf);

    [T,H]=size(HHShare);

    OElas=zeros(H*T,1);                   %TxnHH
    for i=1:H
        OElas(1+(i-1)*T:T*i)=diag(HHElas(:,:,i));
    end

    HHCode=kron(SortedHHCode,ones(T,1));
    ProdCode=repmat(SortedProductCodeRaw,[H 1]);

    Elasdata=[HHCode ProdCode OElas reshape(HHShare,[H*T 1])];
    oout=fullfile(out,'Elasticities\Linearized',['elasticity',J,'.raw']);
    save(oout,'Elasdata','-ascii','-double','-tabs'); 
end

%%%Compensating variation

%Cubic
inf=fullfile(in,cubic,'bootstrap\boot_B1.mat');
load(inf);

Outdata=squeeze(CV(:,1,:));
outf=fullfile(out,'CV_Nonlinear.raw');
save(outf,'Outdata','-ascii','-double','-tabs');

Outdata=squeeze(CV(:,2,:));
outf=fullfile(out,'CV_Nonlinear_ad.raw');
save(outf,'Outdata','-ascii','-double','-tabs');

%Linear
inf=fullfile(in,linear,'bootstrap\boot_B1.mat');
load(inf);

Outdata=squeeze(CV(:,1,:));
outf=fullfile(out,'CV_Linear.raw');
save(outf,'Outdata','-ascii','-double','-tabs');

Outdata=squeeze(CV(:,2,:));
outf=fullfile(out,'CV_Linear_ad.raw');
save(outf,'Outdata','-ascii','-double','-tabs');

%Preference shifter
inf=fullfile(in,pref,'bootstrap\boot_B1.mat');
load(inf);

Outdata=squeeze(CV(:,1,:));
outf=fullfile(out,'CV_PrefShift.raw');
save(outf,'Outdata','-ascii','-double','-tabs');

Outdata=squeeze(CV(:,2,:));
outf=fullfile(out,'CV_PrefShift_ad.raw');
save(outf,'Outdata','-ascii','-double','-tabs');

%Linearized
inf=fullfile(in,approx,'bootstrap\boot_B1.mat');
load(inf);

Outdata=squeeze(CV(:,1,:));
outf=fullfile(out,'CV_Approx.raw');
save(outf,'Outdata','-ascii','-double','-tabs');

Outdata=squeeze(CV(:,2,:));
outf=fullfile(out,'CV_Approx_ad.raw');
save(outf,'Outdata','-ascii','-double','-tabs');
