function [Subset,TempDirList] = ComputePartition(nProcessors,nMarkets,OutDir)
% Given a number of processors and a number of markets, define subsets
% of markets to send to each processor.
% Also define temporary directories to store temporary results.

Subset = cell(nProcessors,1);
% n1: number of markets per processor (rounded down)
% n2: number of processors computing n1+1 markets
% n3: number of processors computing n1 markets

n1 = floor(nMarkets/nProcessors);
n2 = nMarkets - n1*nProcessors;
n3 = nProcessors - n2;

aa=reshape((1:n3*n1)',[n1 n3]);
% Assign markets to first n3 processors
for i1=1:n3
%  Subset{i1} = aa(:,i1)';
  Subset{i1} = (1:nMarkets);
end

% assign markets to remaining processors
aa = reshape(n3*n1+(1:n2*(n1+1))',[n1+1 n2]);
for i1=1:n2
%  Subset{n3+i1} = aa(:,i1)';
  Subset{n3+i1} = (1:nMarkets);
end

% create directories to store temporary results
TempDirList = cell(nProcessors,1);
for i1=1:nProcessors
  TempDirList{i1} = fullfile(OutDir,['temp',int2str(i1)]);
  if exist(TempDirList{i1},'dir')==0
    system(['mkdir ',TempDirList{i1}]);
  end
end