function  [HHTaxPrice,HHTaxShare,TaxPrice] ...
        = ComputeTaxShare(Tax,xFree2,iFree2,beta2,CDiag,COffDiag,X,Z,    ...
                          LogNormalFlag,LogNormalIndex, ...
                          basis,EstColumn,ZIndex,    ...
                          noptions,nHH,RCDim,RCRank,nFirms,      ...
                          AllFirmsProducts,NewHHProductCode,        ...
                          Nodes,Weights,nQuadAll,BasePrice,HHPrice, ...
                          Sats,nMarkets)
% Revision history
% 2017MAR18  Cleaned version for publication.
                      
if Tax.Type==1                        
  HHTaxPrice = reshape(HHPrice,noptions,nHH)+repmat(Tax.tax*Sats,[1 nHH]);
  TaxPrice   = BasePrice + Tax.tax*repmat(Sats,[1 nMarkets]);
elseif Tax.Type==2
  HHTaxPrice = reshape(HHPrice,noptions,nHH).*repmat(1+Tax.tau*Sats,[1 nHH]);
  TaxPrice   = BasePrice.*(1+Tax.tau*repmat(Sats,[1 nMarkets]));
elseif Tax.Type==3
 HHTaxPrice = HHPrice;
 TaxPrice   = BasePrice;
end
HHTaxPrice     = HHTaxPrice(:);
NewExpenditure = X.GrossExpenditure - HHTaxPrice;

iNonZero = HHPrice~=0;

% insert HHTaxPrice into (X,Z,GradX,HessX)
[X,Z]=UpdatePriceTerms(NewExpenditure,X,Z,basis,EstColumn,ZIndex, ...
                       iNonZero,RCDim);

HHTaxShare=MarketShare(X,Z,xFree2,iFree2,beta2,CDiag,COffDiag, ... 
                       LogNormalFlag,LogNormalIndex,EstColumn,ZIndex, ...
                       noptions,nHH,RCDim,RCRank,nFirms,      ...
                       AllFirmsProducts,NewHHProductCode,        ...
                       Nodes,Weights,nQuadAll);