function Tau = Compute_AV_Tau(BaseTax_ProductLevelResultsRawFile, ...
                              BaseTax,                            ...
                              noptions)
% Compute value of Tau for ad valorem tax that yields same revenues as 
% baseline excise tax.
%
% Revision history
% 2017MAR19  Cleaned version for publication.

% Compute baseline ad valorem tax

% Load product level Tax results
TaxResults=load(BaseTax_ProductLevelResultsRawFile);
[n1,n2]=size(TaxResults);

TaxResults=reshape(TaxResults,noptions,n1/noptions,n2);
iNutrient  = 3;
iBasePrice = 8;
iBaseShare = 9;

% Tax experiment 1:
%   TaxPrice = BasePrice*tau*Sats
%  
%   tax*sum(Sats.*BaseShare) = tau * sum(Sats.*BaseShare.*BasePrice)
%
%   tau = tax * sum(Sats.*BaseShare) / sum(Sats.*BaseShare.*BasePrice)
Sats = mean(squeeze(TaxResults(:,:,iNutrient)),2);
BaseShare = mean(squeeze(TaxResults(:,:,iBaseShare)),2);
BasePrice = mean(squeeze(TaxResults(:,:,iBasePrice)),2);
Tau = BaseTax * (Sats'*BaseShare) / sum(Sats.*BaseShare.*BasePrice);