function [Market,nHH] = ...
    DefineMarket(SortedData,RawColumn,MarketDefinition, ...
                 noptions,nMonths,nRegions)
% Define market given current settings
%
% Revision history
% 2017MAR18  Cleaned version for publication.

nHH=sum(SortedData(:,RawColumn.Choice)==1);                    
if MarketDefinition==1
  % all data in one market
  Market = ones(nHH*noptions,1);
%  nMarkets=1;
elseif MarketDefinition==2
  % each month is a market
  Market = SortedData(:,RawColumn.Month);
%  nMarkets=nMonths;
elseif MarketDefinition==3
  % each region is a market
  Market = SortedData(:,RawColumn.Region);
%  nMarkets=nRegions;
elseif MarketDefinition==4
  % each (month,region) is a market
%  nMarkets=nMonths*nRegions;
  Market=zeros(nHH*noptions,1);
  
  for m=1:nMonths
  for r=1:nRegions
    i1 = SortedData(:,RawColumn.Month)==m & ...
         SortedData(:,RawColumn.Region)==r;
    Market(i1) = nRegions*(m-1)+r;
  end
  end
end