function  [AllFirmsProducts,AllCompetitorProducts,   ...
           SortedHHFirmCode,SortedFirmCode,nFirms] = ...
    DefineOwnership(OwnershipFlag)

% Load data on firms
FirmData=importdata(FirmDataFile);

OwnershipMatrix=FirmData.data;
ProductCodeRaw=str2double(FirmData.textdata(2:noptions+1,1));
nFirms=size(OwnershipMatrix,2);
  
% Create HHFirmCode: FirmCode mapped to HH level data
% Create FirmCode:   code number firm
% Renumber HHProductCodeRaw and ProductCodeRaw so that they are integers from 1 - noptions
%
HHFirmCode=zeros(noptions*nHH,1);
FirmCode=zeros(noptions,1);
for j=1:noptions
  f=find(OwnershipMatrix(j,:)==1);
  HHFirmCode(HHProductCodeRaw==ProductCodeRaw(j))=f;
  FirmCode(ProductCodeRaw==ProductCodeRaw(j))=f;
end

