function [R,J]=Equilibrium2_wrapper(FreePrice,iPrice, ...
                                    Price,Cost,Tax,Sats, ...
                                    HHWeights,X,Z,iNonZero,basis, ...
                                    noptions,nHH,RCDim,RCRank, ...
                                    LogNormalFlag,LogNormalIndex,EstColumn,ZIndex, ...
                                    xFree2,iFree2,beta2,CDiag,COffDiag,nFirms,  ... 
                                    AllFirmsProducts,AllCompetitorProducts, ...
                                    NewHHProductCode,Nodes,Weights,nQuadAll, ...
                                    MaxN)
% Enables call to Equilibrium 2 with only a subset of prices allowed to be 
% free.
%
% Revision history
% 2017MAR19  Cleaned version for publication.

Price(iPrice)=FreePrice;

if nargout==2
  [RTemp,JTemp]=Equilibrium2(Price,Cost,Tax,Sats,  ...
                             HHWeights,X,Z,iNonZero,basis, ...
                             noptions,nHH,RCDim,RCRank,   ...
                             LogNormalFlag,LogNormalIndex,EstColumn,ZIndex, ...
                             xFree2,iFree2,beta2,CDiag,COffDiag, ... 
                             nFirms,AllFirmsProducts, ...
                             AllCompetitorProducts,   ...
                             NewHHProductCode, ...
                             Nodes,Weights,nQuadAll,MaxN);
                         
            
J=JTemp(iPrice,iPrice);
                         
elseif nargout==1

  RTemp=Equilibrium2(Price,Cost,Tax,Sats,  ...
                     HHWeights,X,Z,iNonZero,basis,noptions,nHH,RCDim,RCRank,   ...
                     LogNormalFlag,LogNormalIndex,EstColumn,ZIndex, ...
                     xFree2,iFree2,beta2,CDiag,COffDiag, ... 
                     nFirms,AllFirmsProducts, ...
                     AllCompetitorProducts,   ...
                     NewHHProductCode, ...
                     Nodes,Weights,nQuadAll,MaxN);
end

R=RTemp(iPrice);                
