function [S,GradS,FullGradS,Hess]=  ...
          Equilibrium2a(xFree2,iFree2,beta2,CDiag,COffDiag,    ...
          HHWeights,X,Z,LogNormalFlag,LogNormalIndex,EstColumn,ZIndex, ...
          noptions,nTemp,RCDim,RCRank,nFirms,  ...
          AllFirmsProducts,NewHHProductCode, ...
          Nodes,Weights,nQuadAll,Tax,Sats,AllCompetitorProducts)
% Compute intermediate outputs for Equilibrium2.m
%   (operates only on subset of data)
%
% Revision history
% 2017MAR19 Cleaned version for publication 

if nargout<=2
  %  Z.z1=Z.z1(index,:);
  %  Z.z2=Z.z2(index,:);
  [S,GradS]=  ...
   MarketShare2(X,Z,xFree2,iFree2,beta2,CDiag,COffDiag, ...
                LogNormalFlag,LogNormalIndex,EstColumn,ZIndex, ...
                noptions,nTemp,RCDim,RCRank,nFirms,  ...
                AllFirmsProducts,NewHHProductCode, ...
                Nodes,Weights,nQuadAll,Tax,Sats);
  TempWeights=reshape(HHWeights,noptions,nTemp);          
  S=S.*TempWeights;
  GradS = GradS.*permute(repmat(TempWeights',[1 1 noptions]),[2 3 1]);
elseif nargout>2
  % Additional outputs required to compute Jacobian
  %  Z.z1=Z.z1(index,:);
  %  Z.z2=Z.z2(index,:);
  [S,GradS,FullGradS,Hess] = ...
     MarketShare2(X,Z,xFree2,iFree2,beta2,CDiag,COffDiag, ... 
                  LogNormalFlag,LogNormalIndex,EstColumn,ZIndex, ...
                  noptions,nTemp,RCDim,RCRank,nFirms,  ...
                  AllFirmsProducts,NewHHProductCode, ...
                  Nodes,Weights,nQuadAll,Tax,Sats,AllCompetitorProducts);
  TempWeights = reshape(HHWeights,noptions,nTemp);
  S=S.*TempWeights;
  Hess = Hess.* permute(repmat(TempWeights',[1 1 noptions noptions]),[2 3 4 1]);
  TempWeights = permute(repmat(TempWeights',[1 1 noptions]),[2 3 1]);
  GradS = GradS.*TempWeights;
  FullGradS = FullGradS.*TempWeights;
end % if nargout>2