function ErrFlag=TestDataLoad(data,nHH,noptions,HHIndex,ChoiceIndex,ProductCodeIndex)
% ErrFlag=TestDataLoad(data,nHH,noptions,HHIndex,ChoiceIndex,ProductCodeIndex)
%
% Revision History
% 2017MAR18   Revised for QE.

% Check that data loaded is correctly.
ErrFlag=zeros(4,1);
% 1) ErrFlag(1)=1:    Some of choice should  be 1 for each hh. At least,
%                     one HH fails this test.
choice=reshape(data(:,ChoiceIndex),noptions,nHH);
ErrFlag(1)=any(sum(choice)'~=1);

% 2) check 
% ErrFlag(2)=1:   choice(noptions,i1) should equal 1 for all hh. At least
%                 one, fails this test.
ErrFlag(2)=any(choice(noptions,:)'~=1);

% 3) check each product appears nHH times, once per hh.
% 
products=reshape(data(:,ProductCodeIndex),noptions,nHH);
for j1=1:noptions
  jCurrent=products(j1,:);
  test1=sum(products==repmat(jCurrent,[noptions 1]));
  if any(test1~=1)
    ErrFlag(3)=ErrFlag(3)+1;
  end
end

% 4) check HHID is same within housheold
% Within HH, HHID should be a constant. ErrFlag(4)=1:, at least 1 hh fails
%                                       this test.
HHID=reshape(data(:,HHIndex),noptions,nHH);
temp= HHID~=repmat(HHID(1,:),[noptions 1]);
ErrFlag(4) = any(temp(:));