function HHElas1=TestElasticity(MarketShareHandle,UpdatePriceHandle, ...
                                X,HHShare,rows,noptions,nobs)
% Revision History
% 2017MAR18  Cleaned version for publication.

HHPrice0=reshape(X.Price,noptions,nobs);
HHExpenditure0 = reshape(X.GrossExpenditure-X.Price,noptions,nobs);

J=length(rows);
HHElas1 = zeros(J,noptions,nobs);
for j=1:J
  HHExpenditure1=HHExpenditure0;
  HHExpenditure1(rows(j),:)=HHExpenditure0(rows(j),:)+1e-4;
  [X,Z]=UpdatePriceHandle(HHExpenditure1(:));
  HHShare1=MarketShareHandle(X,Z); 
  
  HHExpenditure2=HHExpenditure0;
  HHExpenditure2(rows(j),:) = 2*HHExpenditure0(rows(j),:)-HHExpenditure1(rows(j),:);
  [X,Z]=UpdatePriceHandle(HHExpenditure2(:));
  HHShare2=MarketShareHandle(X,Z); 
    
  % size(HHShare1) = (noptions x nobs)
  temp=(HHShare1-HHShare2).' ...
        ./ repmat((HHExpenditure1(rows(j),:)-HHExpenditure2(rows(j),:)).',[1 noptions]);
  temp=temp.*repmat(HHPrice0(rows(j),:)',[1 noptions])./HHShare.';
  temp = temp.';
  % size(temp) = (noptions x nobs)
  
  HHElas1(j,:,:)=reshape(full(temp),[1 noptions nobs]);
  disp(rows(j))
end % for j=1:J  