function [R0,J0,J1]=TestEquilibrium2(Price,Cost,Tax,Sats,iFreePrice, ...
                                     HHWeights,X,Z,iNonZero,basis,   ...
                                     noptions,nobs,RCDim,RCRank,  ...
                                     LogNormalFlag,LogNormalIndex, ...
                                     EstColumn,ZIndex,     ...
                                     xFree2,iFree2,beta2,CDiag,COffDiag,nFirms,   ... 
                                     AllFirmsProducts,AllCompetitorProducts, ...
                                     NewHHProductCode, ...
                                     Nodes,Weights,nQuadAll,MaxN)
% Revision history
% 2017MAR19  Cleaned version for publication

[R0,J0]=Equilibrium2(Price,Cost,Tax,Sats, ...
                     HHWeights,           ...
                     X,Z,iNonZero,basis,  ...
                     noptions,nobs,RCDim,RCRank, ...
                     LogNormalFlag,LogNormalIndex,EstColumn,ZIndex, ...
                     xFree2,iFree2,beta2,CDiag,COffDiag,nFirms,  ... 
                     AllFirmsProducts,AllCompetitorProducts, ...
                     NewHHProductCode, ...
                     Nodes,Weights,nQuadAll,MaxN);
                 
J1=zeros(noptions,noptions);
for j=iFreePrice'
  disp(j);
  Price1=Price;
  Price2=Price;
  Price1(j)=Price(j)+1e-4;
  Price2(j)=2*Price(j)-Price1(j);
  
  R1=Equilibrium2(Price1,Cost,Tax,Sats, ...
                  HHWeights,            ...
                  X,Z,iNonZero,basis,   ...
                  noptions,nobs,RCDim,RCRank,  ...
                  LogNormalFlag,LogNormalIndex,EstColumn,ZIndex,       ...
                  xFree2,iFree2,beta2,CDiag,COffDiag,nFirms,  ... 
                  AllFirmsProducts,AllCompetitorProducts, ...
                  NewHHProductCode, ...
                  Nodes,Weights,nQuadAll,MaxN);
  R2=Equilibrium2(Price2,Cost,Tax,Sats, ...
                  HHWeights,            ...
                  X,Z,iNonZero,basis,   ...
                  noptions,nobs,RCDim,RCRank,  ...
                  LogNormalFlag,LogNormalIndex,EstColumn,ZIndex, ...
                  xFree2,iFree2,beta2,CDiag,COffDiag,nFirms,  ... 
                  AllFirmsProducts,AllCompetitorProducts, ...
                  NewHHProductCode, ...
                  Nodes,Weights,nQuadAll,MaxN);

  J1(:,j)=(R1-R2)/(Price1(j)-Price2(j));              
end

R0 = R0(iFreePrice);
J0 = J0(iFreePrice,iFreePrice);
J1 = J1(iFreePrice,iFreePrice);