function exitflag = ...
    TestEquilibrium2_wrapper(FreePrice,iPrice,InitialPrice,Cost,Tax,    ...
                             Sats,HHWeights,X,Z,iNonZero,basis,noptions,      ...
                             nHH,RCDim,RCRank,LogNormalFlag,LogNormalIndex, ...
                             EstColumn,ZIndex,xFree2,iFree2,beta2,      ...
                             CDiag,COffDiag,nFirms,AllFirmsProducts,    ...
                             AllCompetitorProducts,HHProductCode,Nodes, ...
                             Weights,nQuadAll,MaxN)

% Test that Equilibrium2 and Equilibrium2_wrapper generate same results.
%
% Revision history
% 2017MAR19  Cleaned version for publication.

Residual1 = ...
  @(Price)Equilibrium2_wrapper(Price,iPrice,InitialPrice,Cost,          ...
                               Tax,Sats,HHWeights,X,Z,iNonZero,basis,   ...
                               noptions,nHH,RCDim,RCRank,LogNormalFlag, ...
                               LogNormalIndex,EstColumn,ZIndex,xFree2,  ...
                               iFree2,beta2,CDiag,COffDiag,nFirms,AllFirmsProducts, ...
                               AllCompetitorProducts,HHProductCode,    ...
                               Nodes,Weights,nQuadAll,MaxN);

Residual2 = @(Price)Equilibrium2(Price,Cost,Tax,Sats,HHWeights,X,Z,iNonZero, ...
                                 basis,noptions,nHH,RCDim,RCRank,          ...
                                 LogNormalFlag,LogNormalIndex,       ...
                                 EstColumn,ZIndex,                   ...
                                 xFree2,iFree2,beta2,CDiag,COffDiag, ...
                                 nFirms,AllFirmsProducts,            ...
                                 AllCompetitorProducts,              ...
                                 HHProductCode,Nodes,Weights,        ...
                                 nQuadAll,MaxN);  

R1 = Residual1(FreePrice);
R2 = Residual2(InitialPrice);

exitflag = max(abs(R1-R2(iPrice)));
