function GradErr = TestLike(LikeFunc,x0,HessFlag)
if nargin<3
  HessFlag=0;
end
n=length(x0);
if HessFlag==0
  [L0,GradL0]=LikeFunc(x0);
elseif HessFlag==1
   [L0,GradL0,Hess0]=LikeFunc(x0);
   Hess1 = zeros(n,n);
end

ComplexStepFlag=0;

h=1e-4;
GradL1  = zeros(n,1);
GradL2  = zeros(n,1);
GradErr = zeros(n,2);

AbsFlag=0;
if ComplexStepFlag==0
  if HessFlag==0
    for i1=45:n % 1:n
      x1=x0;
      x2=x0;
      if AbsFlag==1
        x1(i1) = x0(i1) + h;
      else
        x1(i1) = x0(i1) + h*max(abs(x0(i1)),1.0);
      end
      x2(i1) = 2*x0(i1)-x1(i1);
      L1 = LikeFunc(x1);
      L2 = LikeFunc(x2);
      GradL1(i1) = (L1-L2)/(x1(i1)-x2(i1));
      GradErr(i1,1) = abs((GradL0(i1)-GradL1(i1)))/max(1,abs(GradL0(i1)));
      GradL2(i1) = (L1-L0)/(x1(i1)-x0(i1));
      GradErr(i1,2) = abs(GradL2(i1)-GradL0(i1))/max(1,abs(GradL0(i1)));
      disp([i1 x0(i1) GradL0(i1) GradL1(i1) GradL2(i1)  GradErr(i1,1)]);
    end
  elseif HessFlag==1
    for i1=1:n
      x1 = x0;
      x2 = x0;
      if AbsFlag==0
        x1(i1) = x0(i1)+h*max(1,abs(x0(i1)));
      else
        x1(i1) = x0(i1) + h;
      end
      x2(i1) = 2*x0(i1)-x1(i1);
      [L1,DL1]=LikeFunc(x1);
      [L2,DL2]=LikeFunc(x2);
      
      Hess1(:,i1) = (DL1-DL2)/(x1(i1)-x2(i1));
      GradL1(i1) = (L1-L2)/(x1(i1)-x2(i1));
      GradErr(i1,1) = abs((GradL0(i1)-GradL1(i1)))/max(1,abs(GradL0(i1)));
      GradL2(i1) = (L1-L0)/(x1(i1)-x0(i1));
      GradErr(i1,2) = abs(GradL2(i1)-GradL0(i1))/max(1,abs(GradL0(i1)));
      disp([i1 x0(i1) GradL0(i1) GradL1(i1) GradL2(i1)  GradErr(i1,1)]);
      disp([i1 x0(i1) Hess0(i1,i1) Hess1(i1,i1), ...
            max(abs(Hess0(:,i1)-Hess1(:,i1))./max(1,abs(Hess0(:,i1))))]);
    end  
  end % if HessFlag==0
elseif ComplexStepFlag==1
  for i1=1:n
    x1=x0;
    x1(i1) = x0(i1) + h*1i;
    L1 = LikeFunc(x1);
    GradL1(i1) = imag(L1)/h;
    GradErr(i1,1) = abs((GradL0(i1)-GradL1(i1)))/max(1,abs(GradL0(i1)));
    disp([i1 x0(i1) GradL0(i1) GradL1(i1) GradErr(i1,1)]);
  end
end