function HHGradS1=TestMarketShare(MarketShareHandle,rows,noptions,nobs,  ...
                                  HHGradS,X,Z,basis,EstColumn,ZIndex,    ...
                                  RCDim)
% Compute numerical gradient of MarketShare for each row in rows.
% rows    = (n x 1)  indexes of rows to compute in HHGradS
%
% Revision history
% 2017MAR18  Cleaned version for publication.
HHGradS1=zeros(noptions,noptions,nobs);

iNonZero = X.Price~=0;
J=length(rows);
HHExpenditure0 = reshape(X.GrossExpenditure-X.Price,noptions,nobs);

for j=1:J
  HHExpenditure1=HHExpenditure0;
  HHExpenditure1(rows(j),:)=HHExpenditure0(rows(j),:)+1e-4;
  [X,Z]=UpdatePriceTerms(HHExpenditure1(:),X,Z,basis,EstColumn,ZIndex, ...
                         iNonZero,RCDim);
  HHShare1 = MarketShareHandle(X,Z);

  HHExpenditure2 = HHExpenditure0;
  HHExpenditure2(rows(j),:) = 2*HHExpenditure0(rows(j),:)-HHExpenditure1(rows(j),:);
  [X,Z]=UpdatePriceTerms(HHExpenditure2(:),X,Z,basis,EstColumn,ZIndex, ...
                         iNonZero,RCDim);
  HHShare2 = MarketShareHandle(X,Z);

  temp=(HHShare1-HHShare2)' ...
      ./ repmat((HHExpenditure1(rows(j),:)-HHExpenditure2(rows(j),:))', ...
                [1 noptions]);
  HHGradS1(rows(j),:,:)=temp';
  disp(rows(j))
end

% In HHGradS, derivative of firm j share w.r.t. prices of other firms is
% set equal to zero.

HHGradS1(HHGradS==0) = 0;

aa=HHGradS(rows,:,:)-HHGradS1(rows,:,:);
aa=aa(:);
result=max(abs(aa));
disp(result)