function  ExitFlag = TestMarketShareAll(MarketShareHandle, ...
                                        MarketShare2Handle, ...
                                        rows,noptions,nHH,  ...
                                        X,Z,basis,EstColumn,ZIndex, ...
                                        RCDim)
                                     
% 1) Test accuracy of HHGradS1 vs numerical gradient
[HHShare1,HHGradS1]= MarketShareHandle(X,Z);

% Compute HHGradS1N(j,:,:) for each j in rows
HHGradS1N = TestMarketShare(MarketShareHandle,rows,noptions,nHH, ...
                            HHGradS1,X,Z,basis,EstColumn,ZIndex, ...
                            RCDim);

e1 = HHGradS1(rows,:,:)-HHGradS1N(rows,:,:);                        
e1 = max(abs(e1(:)));                        

% 2) test GradS = FullGradS within firm
[HHShare2,HHGradS2,FullGradS2,Hess2 ] = MarketShare2Handle(X,Z);

% check that HHShare's are equal
e2 = max(abs(HHShare1(:)-HHShare2(:)));

% 3) check that HHGradS1 = HHGradS2
e3 = max(abs(HHGradS1(:)-HHGradS2(:)));

% 4) check that HHGradS2 = FullGradS2 whenever the former~=0
TempFullGradS = FullGradS2;
TempFullGradS(HHGradS2==0)=0;
e4 = max(abs(HHGradS2(:)-TempFullGradS(:)));

% 5) test FullGradS is accurate
FullGradS2N = TestMarketShare2(MarketShare2Handle,rows,noptions,nHH,  ...
                               FullGradS2,X,Z,basis,EstColumn,ZIndex, ...
                               RCDim);
e5 = FullGradS2(rows,:,:)-FullGradS2N(rows,:,:);
e5 = max(abs(e5(:)));
% 4 test Hess is accurate
Hess2N = TestMarketShareHess(MarketShare2Handle,rows,noptions,nHH, ...
                             X,Z,basis,EstColumn,ZIndex,RCDim);

e6 = Hess2(rows,rows,rows,:)-Hess2N(rows,rows,rows,:);
e6 = max(abs(e6(:)));
ExitFlag = [e1 e2 e3 e4 e5 e6]';
