function Hess2N = TestMarketShareHess(MarketShare2Handle,rows,noptions,nHH, ...
                                      X,Z,basis,EstColumn,ZIndex, ...
                                      RCDim)
% Compute numerical hessian of MarketShares for each row in rows.
%
% rows    = (n x 1)  indexes of rows to compute in HHGradS
%
% Revision history
% 21OCT2013 LN SmallZ Version
% 06may2013 LN adapt from FatTax

[~,~,~,Hess2]=MarketShare2Handle(X,Z);

Hess2N=zeros(noptions,noptions,noptions,nHH);

% columns of X containing x*p
iNonZero = X.Price~=0;

J=length(rows);

HHExpenditure0 = reshape(X.GrossExpenditure-X.Price,noptions,nHH);
for j1=1:J
  HHExpenditure1             = HHExpenditure0;
  HHExpenditure1(rows(j1),:) = HHExpenditure0(rows(j1),:)+1e-4;
  [X,Z]=UpdatePriceTerms(HHExpenditure1(:),X,Z,basis,EstColumn,ZIndex, ...
                         iNonZero,RCDim);
 
  [~,GradS2A] = MarketShare2Handle(X,Z);
  
  HHExpenditure2             = HHExpenditure0;
  HHExpenditure2(rows(j1),:) = 2*HHExpenditure0(rows(j1),:)-HHExpenditure1(rows(j1),:);
  [X,Z]=UpdatePriceTerms(HHExpenditure2(:),X,Z,basis,EstColumn,ZIndex, ...
                         iNonZero,RCDim);

  [~,GradS2B] = MarketShare2Handle(X,Z);
  
  temp=(GradS2A-GradS2B)/(HHExpenditure1(rows(j1),1)-HHExpenditure2(rows(j1),1));
  Hess2N(:,rows(j1),:,:)=reshape(temp,[noptions 1 noptions nHH]);
  aa = squeeze(Hess2(rows,rows(j1),rows,:)-Hess2N(rows,rows(j1),rows,:));
  disp([rows(j1) max(abs(aa(:)))])
end
Hess2N(Hess2==0) = 0;
