function e = TestUpdatePrice(SortedData,RawColumn,ZIndex, ...
                             NewDataHandle,UpdatePriceHandle)    
% 1) X.X
% 2) X.GradX
% 3) X.HessX
% 4) Z.Z(:,i1) for all i1 in ZIndex.iP
% 5) Z.GradZ(:,i1) for all i1 in ZIndex.iP
% 6) Z.HessZ(:,i1) for all i1 in ZIndex.iP

expenditure = SortedData(:,RawColumn.Expenditure);
price       = SortedData(:,RawColumn.Price);
iNonZero1   = price>0;

NewExpenditure = expenditure;
NewExpenditure(iNonZero1) = expenditure(iNonZero1)+1e-4;
SortedData(:,RawColumn.Expenditure) = NewExpenditure;
[X1,Z1]=NewDataHandle(SortedData);
[X2,Z2]=UpdatePriceHandle(NewExpenditure);

e=zeros(3+length(ZIndex.iP)*3,1);
% 1) test X1.X - X2.X = 0
e(1) = max(abs(X1.X(:)-X2.X(:)));

% 2) test X1.GradX - X2.GradX = 0
e(2) = max(abs(X1.GradX(:)-X2.GradX(:)));

% 3) test X1.HessX - X2.HessX = 0
e(3) = max(abs(X1.HessX(:)-X2.HessX(:)));

% 4) test Z1.z(i1) = Z2.z(i1) for all i1
for i1=1:length(ZIndex.iP)
  e(3+3*(i1-1)+1) = max(abs(Z1.Z(:,i1)-Z2.Z(:,i1)));
  e(3+3*(i1-1)+2) = max(abs(Z1.GradZ(:,i1)-Z2.GradZ(:,i1)));
  e(3+3*(i1-1)+3) = max(abs(Z1.HessZ(:,i1)-Z2.HessZ(:,i1)));
end
