% Compute a large number of Wald Tests.
b     = beta2;
k     = size(b,1);

sig_b = inv(Hess2(1:k,1:k));

R0=eye(k);

%%-------------------------------------------------------------------------
% Test 1
% Test interactions of price
% 1 but_inc_hi*p*  = 0   [16 17 18] = 0
% 2 but_inc_low*p* = 0   [13 14 15] = 0
% 3 inc_hi*p*      = 0   [10 11 12] = 0
% 4 inc_low*p*     = 0   [7 8 9]    = 0
% 5 but            = 0   [4 5 6 13:18] = 0
% 6 but* inc*      = 0   [13:18']      = 0
% 7 inc_hi*        = 0   [10:12,16:18] = 0
% 8 inc_low*       = 0   [(7:9)';(13:15)'] = 0
nTests = 8;
TestLabel1  = cell(nTests,1);
TestIndex1  = cell(nTests,1);
TestResult1 = zeros(nTests,3);

TestLabel1{1} = 'Price * butter * inc_hi';
TestLabel1{2} = 'Price * butter * inc_low';
TestLabel1{3} = 'Price * inc_hi';
TestLabel1{4} = 'Price * inc_low';
TestLabel1{5} = 'butter';
TestLabel1{6} = 'butter * inc*';
TestLabel1{7} = 'All inc_hi interactions';
TestLabel1{8} = 'All inc_low interactions';


TestIndex1{1} = (16:18)';
TestIndex1{2} = (13:15)';
TestIndex1{3} = (10:12)';
TestIndex1{4} = (7:9)';
TestIndex1{5} = [(4:6)';(13:18)'];
TestIndex1{6} = (13:18)';
TestIndex1{7} = [(10:12)';(16:18)'];
TestIndex1{8} = [(7:9)';(13:15)'];

for i1=1:nTests
  R     = R0(TestIndex1{i1},:);
  q     = zeros(size(TestIndex1{i1},1),1);
  [s,d,crit]=ComputeWaldTest(b,sig_b,R,q);
  TestResult1(i1,:) = [s d crit];
end



%% Output results to file
WaldFile = fullfile(OutDir,'WaldTest.txt');
fid=fopen(WaldFile,'w');
fprintf(fid,'%-15s %-15s %-15s %-30s', ...
            'Deg. Free.',        ...
            'Test Stat.',        ...
            'Crit. Val.',        ...
            'Label');
fprintf(fid,'\n');        

for i1=1:nTests
  fprintf(fid,'%-15.0f %-15.2f %-15.2f %-15s',      ...
          TestResult1(i1,2),  ...
          TestResult1(i1,1),  ...
          TestResult1(i1,3),  ...
          TestLabel1{i1});
  fprintf(fid,'\n');
end


fclose(fid);