function [iw,rw,ifail] = SetNAGOptions(iw,rw,options)

% turn on print out of options
%[iw,rw,ifail] = e04wf('List',iw,rw);

% Set string options
% Major Print Level   1   normal output for linear and nonlinear problems
[iw,rw,ifail] = e04wf('Major Print Level = 1',iw,rw) ;
[iw,rw,ifail] = e04wf('Print Frequency = 100',iw,rw);
[iw,rw,ifail] = e04wf('Print File = 0',iw,rw);
[iw,rw,ifail] = e04wf('Summary File = 6',iw,rw);
[iw,rw,ifail] = e04wf('Summary Frequency = 1',iw,rw);
[iw,rw,ifail] = e04wf('Minor Print Level = 0',iw,rw);

[iw,rw,ifail] = e04wf('Linesearch Tolerance = 0.99',iw,rw);
%[iw,rw,ifail] = e04wf('Nonderivative Linesearch',iw,rw);
[iw,rw,ifail] = e04wf('Hessian Full Memory',iw,rw);
[iw,rw,ifail] = e04wf('Reduced Hessian Dimension = 300',iw,rw);
[iw,rw,ifail] = e04wf('QPSolver Cholesky',iw,rw);

% Derivative Level:  3   all objectives and all constraints known
[iw,rw,ifail] = e04wg('Derivative Level',int64(3),iw,rw);
if strncmp(options.GradObj,'off',3) && strncmp(options.GradConstr,'on',2)
  [iw,rw,ifail] = e04wg('Derivative Level',int64(2),iw,rw);
elseif strncmp(options.GradObj,'on',2) && strncmp(options.GradConstr,'off',3)
  [iw,rw,ifail] = e04wg('Derivative Level',int64(1),iw,rw);
elseif strncmp(options.GradObj,'off',3) && strncmp(options.GradConstr,'off',3)
  [iw,rw,ifail] = e04wg('Derivative Level',int64(0),iw,rw);
end

% Iterations
if ~isempty(options.MaxIter)
  [iw,rw,ifail] = e04wg('Iterations',int64(300*options.MaxIter),iw,rw);
  [iw,rw,ifail] = e04wg('Major Iterations',int64(options.MaxIter),iw,rw);
  [iw,rw,ifail] = e04wg('Minor Iterations Limit',int64(10000),iw,rw);
end

if ~isempty(options.DerivativeCheck)
  if strncmp(options.DerivativeCheck,'on',2)
    [iw,rw,ifail] = e04wg('Verify Level',int64(3),iw,rw);
  end
end