function [x,L,exitflag,output,lambda,grad,hess] ...
    = fmin_wrapper(LikeFunc,x0,A,B,AEQ,BEQ,lower,upper,confun,options, ...
                   optimizer)
if optimizer==1
  [x,L,exitflag,output,lambda,grad,hess]=...
        fmincon(LikeFunc,x0,A,B,AEQ,BEQ,lower,upper,confun,options);
elseif optimizer==2
  extendedFeatures=[];
  [x,L,exitflag,output,lambda] = ...
      knitromatlab(LikeFunc,x0,A,B,AEQ,BEQ,lower,upper,confun, ...
                   extendedFeatures,options);
              
 
  grad = [];
  hess = [];
elseif optimizer==3
  CL     = [];
  CU     = [];
  exitflag = nag_issue_warnings(true);  % if error, create flag but no crash
  [x,L,exitflag,output,lambda,grad,hess] = ...
        CallNAG(LikeFunc,x0,A,B,AEQ,BEQ, ...
                lower,upper,confun,CL,CU,options);
end