function [x1,FunValue,exitflag,output,lambda,grad,Hess]=...
        fmincon_NAG(ObjFun,x0,A,B,lower,upper, ...
                ConFun,ncnln,user)

% Initialise e04wd
[iw,rw,exitflag] = e04wc;
[iw,rw,exitflag] = e04wf('Print Frequency = 1', iw, rw) ;
[iw,rw,exitflag] = e04wf('Major Iterations Limit = 5000', iw, rw) ;
[iw,rw,exitflag] = e04wf('Print File = 6', iw, rw) ;
warnp = nag_issue_warnings(true);

n=int32(size(x0,1));

if isempty(A)
  A=ones(1,1);
  nclin=int32(0);
  cjac=zeros(1,1);
else
 nclin=int32(size(A,1)); 
 cjac = zeros(ncnln,n);
 upper=[upper;B];
 lower=[lower;-inf*ones(size(B))];
end

if isempty(ConFun)
  ConFun = 'e04wdp';
  ncnln=int32(0);
end

istate=int32(zeros(n+nclin+ncnln,1));
ccon=zeros(1,1);
clamda=zeros(n+nclin+ncnln,1);
h=eye(n,n);

[majits,istate,ccon,cjac,lambda,FunValue,grad, ...
   Hess,x1,iw,rw,user,exitflag] = ...
   e04wd(A,lower,upper,ConFun,ObjFun,istate, ...
         ccon,cjac,clamda,h,x0,iw,rw,   ...
         'nclin',nclin, ...
         'ncnln',ncnln, ...
         'user',user) ;
output.majits=majits;
output.istate=istate;
output.ccon  = ccon;
output.cjac  = cjac;