function [x,w]=gauher(n)
%calculate abscissas and weights for Gauss-Hermite quad

if n>198,  error('This routine does not work for n>198'), end

x=zeros(n,1);
w=x;
pi4=pi^(-0.25);
itmax=50;

m=(n+1)/2;

for i=1:m
  if i==1
    z=sqrt(2*n+1)-1.85575*(2*n+1)^(-0.16667);
  elseif i==2
    z=z-1.14*n^(.426)/z;
  elseif i==3
    z=1.86*z-0.86*x(1,1);
  elseif i==4
    z=1.91*z-0.91*x(2,1);
  else
    z=2*z-x(i-2,1);
  end;
 
  for iter=1:itmax
    p1=pi4;
    p2=0;
    for j=1:n
      p3=p2;
      p2=p1; 
      p1=z*sqrt(2/j)*p2-sqrt((j-1)/j)*p3;
    end;
    pp=sqrt(2*n)*p2;
    z1=z;
    z=z1-p1/pp;
    if abs(z-z1)<=eps*(1+z1), break; end;
  end;
  if iter==itmax
    %i
    %keyboard    
    %error('Too many iterations in gauher');
  end;
  x(i,1)=z;
  x(n+1-i,1)=-z;
  w(i)=2/(pp*pp);
  w(n+1-i)=w(i);
  %x(i,2)=2/(pp*pp);
  %x(n+1-i,2)=x(i,2); 
end;
