#!/bin/csh
#
#  Purpose:
#
#    Create a GZIP'ed TAR file of the m_src/sparse_grid_hermite files.
#
#  Modified:
#
#    08 October 2007
#
#  Author:
#
#    John Burkardt
#
#  Move to the directory just above the "sparse_grid_hermite" directory.
#
cd $HOME/public_html/m_src
#
#  Delete any TAR or GZ file in the directory.
#
echo "Remove TAR and GZ files."
rm sparse_grid_hermite/*.tar
rm sparse_grid_hermite/*.gz
#
#  Create a TAR file of the "sparse_grid_hermite" directory.
#
echo "Create TAR file."
tar cvf sparse_grid_hermite_m_src.tar sparse_grid_hermite/*
#
#  Compress the file.
#
echo "Compress the TAR file."
gzip sparse_grid_hermite_m_src.tar
#
#  Move the compressed file into the "sparse_grid_hermite" directory.
#
echo "Move the compressed file into the directory."
mv sparse_grid_hermite_m_src.tar.gz sparse_grid_hermite
#
#  Say goodnight.
#
echo "The sparse_grid_hermite_m_src gzip file has been created."
