function CV = ComputeCV_Dagsvik(V0,HHPrice,X,Z,basis,             ...
                                EstColumn,ZIndex,iNonZero,          ...
                                xFree2,iFree2,beta2,CDiag,COffDiag, ...
                                LogNormalFlag,LogNormalIndex,       ...
                                noptions,nHH,RCDim,RCRank,nQuadAll, ...
                                Nodes,Weights)
% Revision history
% 2017MAR19  Cleaned version for publication.

CV = zeros(nHH,nQuadAll);
V0 = reshape(V0,[noptions*nHH nQuadAll]);

% When YH = Y + NewPrice - Price, then
%  v(YH - NewPrice) = v(Y-Price)
YH = X.GrossExpenditure + HHPrice-X.Price;

method=1;
IntegralHandle = ...
    @(iQuad,V0)ComputeIntegral_Dagsvik(iQuad,V0,YH,HHPrice,X,Z,basis, ...
                                       EstColumn,ZIndex,iNonZero,     ...
                                       xFree2,iFree2,beta2,CDiag,COffDiag,  ...
                                       LogNormalFlag,LogNormalIndex,        ...
                                       noptions,nHH,RCDim,RCRank,Nodes,nQuadAll,method);
parfor iQuad=1:nQuadAll
  CV(:,iQuad) = IntegralHandle(iQuad,V0(:,iQuad));
end

% integrate across random coefficients
% only include positive elements of CV
% some draws from r.c. distribution result in CV<0
CV = max(CV,0)*Weights;