**Tables

u "$P/all_cv.dta",clear

keep if hhm==2

collapse (mean) cubic_ex linear_ex prefshift_ex linearized_ex cubic_ad linear_ad prefshift_ad linearized_ad

gen v = 0

sa "$P/cv_temp.dta",replace

u "$P/all_cv.dta",clear

keep if hhm==2

keep exp cubic_ex linear_ex prefshift_ex linearized_ex cubic_ad linear_ad prefshift_ad linearized_ad

centile exp,centile(25 50 75)
gen     v = 1 if exp<r(c_1)
replace v = 2 if exp<r(c_2) & exp>=r(c_1)
replace v = 3 if exp<r(c_3) & exp>=r(c_2)
replace v = 4 if              exp>=r(c_3)

collapse (mean) cubic_ex linear_ex prefshift_ex linearized_ex cubic_ad linear_ad prefshift_ad linearized_ad,by(v)

append using "$P/cv_temp.dta"
sort v

xpose,clear varname

gen     var = 1 if _var=="cubic_ex"|_var=="cubic_ad"
replace var = 2 if _var=="linear_ex"|_var=="linear_ad"
replace var = 3 if _var=="prefshift_ex"|_var=="prefshift_ad"
replace var = 4 if _var=="linearized_ex"|_var=="linearized_ad"
drop if var==.

gen tax     = 1 if regexm(_var,"_ex")>0
replace tax = 2 if regexm(_var,"_ad")>0

lab def varcv 1 "Cubic utility" 2 "Linear utility" 3 "Preference shifter" 4 "Linearized utility"
lab val var varcv

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n'=q`n'-mean
}

gen stat = "mean"

drop _var
order stat tax var mean q1 q2 q3 q4

sa "$P/cv_results1.dta",replace

u "$DL/cv_multi_ex.dta",clear

keep hhno
gen n = _n

sa "$P/hhnos.dta",replace

insheet using "$M\CV_Nonlinear.raw",clear

drop v101

gen n = _n

merge 1:1 n using "$P/hhnos.dta"
drop _m

merge 1:1 hhno using "$DN/hhweights.dta"
drop _m

foreach n of numlist 1(1)100 {
    qui replace v`n'=v`n'*tripweight
}
drop tripweight demweight

gen hh = hhno
merge m:1 hh using "$P/hh_exp.dta"
keep if _m==3
drop _m
drop hh

keep if hhm==2

sa "$BN/CV.dta",replace

u "$BN/CV.dta",clear

collapse (mean) v*

gen c = 0

sa "$BN/mean_CV.dta",replace

u "$BN/CV.dta",clear

centile exp,centile(25 50 75)
gen     c = 1 if exp<r(c_1)
replace c = 2 if exp<r(c_2) & exp>=r(c_1)
replace c = 3 if exp<r(c_3) & exp>=r(c_2)
replace c = 4 if              exp>=r(c_3)

collapse (mean) v*,by(c)

append using "$BN/mean_CV.dta"

sort c
xpose,clear
drop if _n==1

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n' = q`n'-mean
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 1
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

gen tax = 1

order var tax stat

sa "$P/CV_CIcubicex.dta",replace

insheet using "$M\CV_Nonlinear_ad.raw",clear

drop v101

gen n = _n

merge 1:1 n using "$P/hhnos.dta"
drop _m

merge 1:1 hhno using "$DN/hhweights.dta"
drop _m

foreach n of numlist 1(1)100 {
    qui replace v`n'=v`n'*tripweight
}
drop tripweight demweight

gen hh = hhno
merge m:1 hh using "$P/hh_exp.dta"
keep if _m==3
drop _m
keep if hhm==2

sa "$BN/CV_ad.dta",replace

u "$BN/CV_ad.dta",clear

collapse (mean) v*

gen c = 0

sa "$BN/mean_CV_ad.dta",replace

u "$BN/CV_ad.dta",clear

centile exp,centile(25 50 75)
gen     c = 1 if exp<r(c_1)
replace c = 2 if exp<r(c_2) & exp>=r(c_1)
replace c = 3 if exp<r(c_3) & exp>=r(c_2)
replace c = 4 if              exp>=r(c_3)

collapse (mean) v*,by(c)

append using "$BN/mean_CV_ad.dta"

sort c
xpose,clear
drop if _n==1

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n' = q`n'-mean
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 1
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

gen tax = 2

order var tax stat

sa "$P/CV_CIcubicad.dta",replace

insheet using "$M\CV_Linear.raw",clear

drop v101

gen n = _n

merge 1:1 n using "$P/hhnos.dta"
drop _m

merge 1:1 hhno using "$DL/hhweights.dta"
drop _m

foreach n of numlist 1(1)100 {
    qui replace v`n'=v`n'*tripweight
}
drop tripweight demweight

gen hh = hhno
merge m:1 hh using "$P/hh_exp.dta"
keep if _m==3
drop _m
keep if hhm==2

sa "$BL/CV.dta",replace

u "$BL/CV.dta",clear

collapse (mean) v*

gen c = 0

sa "$BL/mean_CV.dta",replace

u "$BL/CV.dta",clear

centile exp,centile(25 50 75)
gen     c = 1 if exp<r(c_1)
replace c = 2 if exp<r(c_2) & exp>=r(c_1)
replace c = 3 if exp<r(c_3) & exp>=r(c_2)
replace c = 4 if              exp>=r(c_3)

collapse (mean) v*,by(c)

append using "$BL/mean_CV.dta"

sort c
xpose,clear
drop if _n==1

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n' = q`n'-mean
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 2
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

gen tax = 1

order var tax stat

sa "$P/CV_CIlinearex.dta",replace

insheet using "$M\CV_Linear_ad.raw",clear

drop v101

gen n = _n

merge 1:1 n using "$P/hhnos.dta"
drop _m

merge 1:1 hhno using "$DL/hhweights.dta"
drop _m

foreach n of numlist 1(1)100 {
    qui replace v`n'=v`n'*tripweight
}
drop tripweight demweight

gen hh = hhno
merge m:1 hh using "$P/hh_exp.dta"
keep if _m==3
drop _m
keep if hhm==2

sa "$BL/CV_ad.dta",replace

u "$BL/CV_ad.dta",clear

collapse (mean) v*

gen c = 0

sa "$BL/mean_CV_ad.dta",replace

u "$BL/CV_ad.dta",clear

centile exp,centile(25 50 75)
gen     c = 1 if exp<r(c_1)
replace c = 2 if exp<r(c_2) & exp>=r(c_1)
replace c = 3 if exp<r(c_3) & exp>=r(c_2)
replace c = 4 if              exp>=r(c_3)

collapse (mean) v*,by(c)

append using "$BL/mean_CV_ad.dta"

sort c
xpose,clear
drop if _n==1

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n' = q`n'-mean
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 2
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

gen tax = 2

order var tax stat

sa "$P/CV_CIlinearad.dta",replace


insheet using "$M\CV_Prefshift.raw",clear

drop v101

gen n = _n

merge 1:1 n using "$P/hhnos.dta"
drop _m

merge 1:1 hhno using "$DP/hhweights.dta"
drop _m

foreach n of numlist 1(1)100 {
    qui replace v`n'=v`n'*tripweight
}
drop tripweight demweight

gen hh = hhno
merge m:1 hh using "$P/hh_exp.dta"
keep if _m==3
drop _m
keep if hhm==2

sa "$BP/CV.dta",replace

u "$BP/CV.dta",clear

collapse (mean) v*

gen c = 0

sa "$BP/mean_CV.dta",replace

u "$BP/CV.dta",clear

centile exp,centile(25 50 75)
gen     c = 1 if exp<r(c_1)
replace c = 2 if exp<r(c_2) & exp>=r(c_1)
replace c = 3 if exp<r(c_3) & exp>=r(c_2)
replace c = 4 if              exp>=r(c_3)

collapse (mean) v*,by(c)

append using "$BP/mean_CV.dta"

sort c
xpose,clear
drop if _n==1

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n' = q`n'-mean
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 3
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

gen tax = 1

order var tax stat

sa "$P/CV_CIprefex.dta",replace

insheet using "$M\CV_Prefshift_ad.raw",clear

drop v101

gen n = _n

merge 1:1 n using "$P/hhnos.dta"
drop _m

merge 1:1 hhno using "$DP/hhweights.dta"
drop _m

foreach n of numlist 1(1)100 {
    qui replace v`n'=v`n'*tripweight
}
drop tripweight demweight

gen hh = hhno
merge m:1 hh using "$P/hh_exp.dta"
keep if _m==3
drop _m
keep if hhm==2

sa "$BP/CV_ad.dta",replace

u "$BP/CV_ad.dta",clear

collapse (mean) v*

gen c = 0

sa "$BP/mean_CV_ad.dta",replace

u "$BP/CV_ad.dta",clear

centile exp,centile(25 50 75)
gen     c = 1 if exp<r(c_1)
replace c = 2 if exp<r(c_2) & exp>=r(c_1)
replace c = 3 if exp<r(c_3) & exp>=r(c_2)
replace c = 4 if              exp>=r(c_3)

collapse (mean) v*,by(c)

append using "$BP/mean_CV_ad.dta"

sort c
xpose,clear
drop if _n==1

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n' = q`n'-mean
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 3
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

gen tax = 2

order var tax stat

sa "$P/CV_CIprefad.dta",replace


insheet using "$M\CV_Approx.raw",clear

drop v101

gen n = _n

merge 1:1 n using "$P/hhnos.dta"
drop _m

merge 1:1 hhno using "$DA/hhweights.dta"
drop _m

foreach n of numlist 1(1)100 {
    qui replace v`n'=v`n'*tripweight
}
drop tripweight demweight

gen hh = hhno
merge m:1 hh using "$P/hh_exp.dta"
keep if _m==3
drop _m
keep if hhm==2

sa "$BA/CV.dta",replace

u "$BA/CV.dta",clear

collapse (mean) v*

gen c = 0

sa "$BA/mean_CV.dta",replace

u "$BA/CV.dta",clear

centile exp,centile(25 50 75)
gen     c = 1 if exp<r(c_1)
replace c = 2 if exp<r(c_2) & exp>=r(c_1)
replace c = 3 if exp<r(c_3) & exp>=r(c_2)
replace c = 4 if              exp>=r(c_3)

collapse (mean) v*,by(c)

append using "$BA/mean_CV.dta"

sort c
xpose,clear
drop if _n==1

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n' = q`n'-mean
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 4
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

gen tax = 1

order var tax stat

sa "$P/CV_CIapproxex.dta",replace

insheet using "$M\CV_Approx_ad.raw",clear

drop v101

gen n = _n

merge 1:1 n using "$P/hhnos.dta"
drop _m

merge 1:1 hhno using "$DA/hhweights.dta"
drop _m

foreach n of numlist 1(1)100 {
    qui replace v`n'=v`n'*tripweight
}
drop tripweight demweight

rename hhno hh
merge m:1 hh using "$P/hh_exp.dta"
keep if _m==3
drop _m
keep if hhm==2

sa "$BA/CV_ad.dta",replace

u "$BA/CV_ad.dta",clear

collapse (mean) v*

gen c = 0

sa "$BA/mean_CV_ad.dta",replace

u "$BA/CV_ad.dta",clear

centile exp,centile(25 50 75)
gen     c = 1 if exp<r(c_1)
replace c = 2 if exp<r(c_2) & exp>=r(c_1)
replace c = 3 if exp<r(c_3) & exp>=r(c_2)
replace c = 4 if              exp>=r(c_3)

collapse (mean) v*,by(c)

append using "$BA/mean_CV_ad.dta"

sort c
xpose,clear
drop if _n==1

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n' = q`n'-mean
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 4
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

gen tax = 2

order var tax stat

sa "$P/CV_CIapproxad.dta",replace

u "$P/cv_results1.dta",clear

append using "$P/CV_CIcubicex.dta"
append using "$P/CV_CIcubicad.dta"
append using "$P/CV_CIlinearex.dta"
append using "$P/CV_CIlinearad.dta"
append using "$P/CV_CIprefex.dta"
append using "$P/CV_CIprefad.dta"
append using "$P/CV_CIapproxex.dta"
append using "$P/CV_CIapproxad.dta"

foreach v in mean q1 q2 q3 q4 {
    gen `v'out=round(`v',0.01)
    format `v'out %4.2f
    }

drop mean q1 q2 q3 q4

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide meanout q1out q2out q3out q4out, i(var tax) j(stat)

foreach v in mean q1 q2 q3 q4 {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep var tax meanout2 q1out2 q2out2 q3out2 q4out2 CImean CIq1 CIq2 CIq3 CIq4

gen vr = _n
lab def vr 1 "Cubic utility" 2 "Cubic utility" 3 "Linear utility" 4 "Linear utility" 5 "Preference shifter" 6 "Preference shifter" 7 "Linearised utility" 8 "Linearised utility"
lab val vr vr

**Table 4.5
foreach x of numlist 1 3 5  {
    local vrname  :   label  (vr)   `x'
    if `x'==1 listtab meanout2 q1out2 q2out2 q3out2 q4out2 using "$G/CV_T1.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>1  listtab meanout2 q1out2 q2out2 q3out2 q4out2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$G/CV_T1.tex" )
    if `x'==1|`x'==3|`x'==5 listtab CImean CIq1 CIq2 CIq3 CIq4 in `x' ,   rstyle(tabular)  appendto("$G/CV_T1.tex")   begin(&)
    }

**Table 4.7
foreach x of numlist 1 7  {
    local vrname  :   label  (vr)   `x'
    if `x'==1 listtab meanout2 q1out2 q2out2 q3out2 q4out2 using "$G/CV_T2.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>1  listtab meanout2 q1out2 q2out2 q3out2 q4out2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$G/CV_T2.tex" )
    if `x'==1|`x'==7 listtab CImean CIq1 CIq2 CIq3 CIq4 in `x' ,   rstyle(tabular)  appendto("$G/CV_T2.tex")   begin(&)
    }

**Table C1	
foreach x of numlist 2 4 6  {
    local vrname  :   label  (vr)   `x'
    if `x'==2 listtab meanout2 q1out2 q2out2 q3out2 q4out2 using "$G/CV_T3.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>2  listtab meanout2 q1out2 q2out2 q3out2 q4out2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$G/CV_T3.tex" )
    if `x'==2|`x'==4|`x'==6 listtab CImean CIq1 CIq2 CIq3 CIq4 in `x' ,   rstyle(tabular)  appendto("$G/CV_T3.tex")   begin(&)
    }







