
u "$P/all_elas.dta",clear

keep if hhm==2

collapse (mean) cubic_elas linear_elas prefshift_elas linearized_elas

gen c = 0

sa "$P/mean_elas.dta",replace

u "$P/all_elas.dta",clear

keep if hhm==2

centile exp,centile(25 50 75)
gen     c = 1 if exp<r(c_1)
replace c = 2 if exp<r(c_2) & exp>=r(c_1)
replace c = 3 if exp<r(c_3) & exp>=r(c_2)
replace c = 4 if              exp>=r(c_3)

collapse (mean) cubic_elas linear_elas prefshift_elas linearized_elas,by(c)

append using "$P/mean_elas.dta"

sort c

xpose,clear varname

gen     var = 1 if _var=="cubic_elas"
replace var = 2 if _var=="linear_elas"
replace var = 3 if _var=="prefshift_elas"
replace var = 4 if _var=="linearized_elas"
drop if var==.

lab def varcv 1 "Cubic utility" 2 "Linear utility" 3 "Preference shifter" 4 "Linearised utility"
lab val var varcv

rename v1 mean
rename v2 q1
rename v3 q2
rename v4 q3
rename v5 q4

foreach n of numlist 1(1)4 {
    replace q`n'=q`n'-mean
}

gen stat = "mean"

drop _var
order stat var mean q1 q2 q3 q4

sa "$P/elas_results1.dta",replace

***Confidence intervals

foreach n of numlist 1(1)100 {

 insheet using "$M/Elasticities/Nonlinear/elasticity`n'.raw",clear

 rename v1 hh
 rename v2 product
 rename v3 elas
 rename v4 share_basemulti
 drop v5

 drop if product==1
 egen sum=sum(share),by(hh)
 replace share = share/sum
 drop sum

 merge m:1 hh using "$P/hh_exp.dta"
 keep if _m==3
 drop _m

 keep if hhm==2

 replace elas = elas*share_basemulti

 collapse (sum) elas (mean) exp,by(hh)

 sa "$BN/elasticity`n'.dta",replace

 collapse (mean) elas

 gen c = 0

 sa "$BN/elasticity`n'_mean.dta",replace

 u "$BN/elasticity`n'.dta",clear

 centile exp,centile(25 50 75)
 gen     c = 1 if exp<r(c_1)
 replace c = 2 if exp<r(c_2) & exp>=r(c_1)
 replace c = 3 if exp<r(c_3) & exp>=r(c_2)
 replace c = 4 if              exp>=r(c_3)

 collapse (mean) elas ,by(c)

 append using "$BN/elasticity`n'_mean.dta"

 sort c

 xpose,clear

 drop if _n==1

 rename v1 mean
 rename v2 q1
 rename v3 q2
 rename v4 q3
 rename v5 q4

 foreach x of numlist 1(1)4 {
     replace q`x'=q`x'-mean
 }
 sa "$BN/elasticity`n'_bs.dta",replace
}

foreach n of numlist 1(1)100 {

 insheet using "$M/Elasticities/Linear/elasticity`n'.raw",clear

 rename v1 hh
 rename v2 product
 rename v3 elas
 rename v4 share_basemulti
 drop v5

 drop if product==1
 egen sum=sum(share),by(hh)
 replace share = share/sum
 drop sum

 merge m:1 hh using "$P/hh_exp.dta"
 keep if _m==3
 drop _m

 keep if hhm==2

 replace elas = elas*share_basemulti

 collapse (sum) elas (mean) exp,by(hh)

 sa "$BL/elasticity`n'.dta",replace

 collapse (mean) elas

 gen c = 0

 sa "$BL/elasticity`n'_mean.dta",replace

 u "$BL/elasticity`n'.dta",clear

 centile exp,centile(25 50 75)
 gen     c = 1 if exp<r(c_1)
 replace c = 2 if exp<r(c_2) & exp>=r(c_1)
 replace c = 3 if exp<r(c_3) & exp>=r(c_2)
 replace c = 4 if              exp>=r(c_3)

 collapse (mean) elas ,by(c)

 append using "$BL/elasticity`n'_mean.dta"

 sort c

 xpose,clear

 drop if _n==1

 rename v1 mean
 rename v2 q1
 rename v3 q2
 rename v4 q3
 rename v5 q4

 foreach x of numlist 1(1)4 {
     replace q`x'=q`x'-mean
 }
 sa "$BL/elasticity`n'_bs.dta",replace
}

foreach n of numlist 1(1)100 {

 insheet using "$M/Elasticities/Prefshift/elasticity`n'.raw",clear

 rename v1 hh
 rename v2 product
 rename v3 elas
 rename v4 share_basemulti
 drop v5

 drop if product==1
 egen sum=sum(share),by(hh)
 replace share = share/sum
 drop sum

 merge m:1 hh using "$P/hh_exp.dta"
 keep if _m==3
 drop _m

 keep if hhm==2

 replace elas = elas*share_basemulti

 collapse (sum) elas (mean) exp,by(hh)

 sa "$BP/elasticity`n'.dta",replace

 collapse (mean) elas

 gen c = 0

 sa "$BP/elasticity`n'_mean.dta",replace

 u "$BP/elasticity`n'.dta",clear

 centile exp,centile(25 50 75)
 gen     c = 1 if exp<r(c_1)
 replace c = 2 if exp<r(c_2) & exp>=r(c_1)
 replace c = 3 if exp<r(c_3) & exp>=r(c_2)
 replace c = 4 if              exp>=r(c_3)

 collapse (mean) elas ,by(c)

 append using "$BP/elasticity`n'_mean.dta"

 sort c

 xpose,clear

 drop if _n==1

 rename v1 mean
 rename v2 q1
 rename v3 q2
 rename v4 q3
 rename v5 q4

 foreach x of numlist 1(1)4 {
     replace q`x'=q`x'-mean
 }
 sa "$BP/elasticity`n'_bs.dta",replace
}

foreach n of numlist 1(1)100 {

 insheet using "$M/Elasticities/Linearized/elasticity`n'.raw",clear

 rename v1 hh
 rename v2 product
 rename v3 elas
 rename v4 share_basemulti
 drop v5

 drop if product==1
 egen sum=sum(share),by(hh)
 replace share = share/sum
 drop sum

 merge m:1 hh using "$P/hh_exp.dta"
 keep if _m==3
 drop _m

 keep if hhm==2

 replace elas = elas*share_basemulti

 collapse (sum) elas (mean) exp,by(hh)

 sa "$BA/elasticity`n'.dta",replace

 collapse (mean) elas

 gen c = 0

 sa "$BA/elasticity`n'_mean.dta",replace

 u "$BA/elasticity`n'.dta",clear

 centile exp,centile(25 50 75)
 gen     c = 1 if exp<r(c_1)
 replace c = 2 if exp<r(c_2) & exp>=r(c_1)
 replace c = 3 if exp<r(c_3) & exp>=r(c_2)
 replace c = 4 if              exp>=r(c_3)

 collapse (mean) elas ,by(c)

 append using "$BA/elasticity`n'_mean.dta"

 sort c

 xpose,clear

 drop if _n==1

 rename v1 mean
 rename v2 q1
 rename v3 q2
 rename v4 q3
 rename v5 q4

 foreach x of numlist 1(1)4 {
     replace q`x'=q`x'-mean
 }
 sa "$BA/elasticity`n'_bs.dta",replace
}

u "$BN/elasticity1_bs.dta",replace

foreach n of numlist 2(1)100 {
    append using "$BN/elasticity`n'_bs.dta"
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 1
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

order var stat

sa "$P/Elas_CIcubic.dta",replace

u "$BL/elasticity1_bs.dta",replace

foreach n of numlist 2(1)100 {
    append using "$BL/elasticity`n'_bs.dta"
}

foreach v in mean q1 q2 q3 q4 {
    egen cbl_`v'=pctile(`v'),p(2.5)
    egen cbu_`v'=pctile(`v'),p(97.5)
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 2
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

order var stat

sa "$P/Elas_CIlinear.dta",replace

u "$BP/elasticity1_bs.dta",replace

foreach n of numlist 2(1)100 {
    append using "$BP/elasticity`n'_bs.dta"
}

foreach v in mean q1 q2 q3 q4 {
    egen cbl_`v'=pctile(`v'),p(2.5)
    egen cbu_`v'=pctile(`v'),p(97.5)
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 3
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

order var stat

sa "$P/Elas_CIpref.dta",replace

u "$BA/elasticity1_bs.dta",replace

foreach n of numlist 2(1)1000 {
    append using "$BA/elasticity`n'_bs.dta"
}

foreach v in mean q1 q2 q3 q4 {
    egen cbl_`v'=pctile(`v'),p(2.5)
    egen cbu_`v'=pctile(`v'),p(97.5)
}

foreach v in mean q1 q2 q3 q4 {
    egen `v'lb = pctile(`v'),p(2.5)
    egen `v'ub = pctile(`v'),p(97.5)
}

keep if _n==1
keep meanlb q1lb q2lb q3lb q4lb meanub q1ub q2ub q3ub q4ub

gen var = 4
lab val var varcv
reshape long mean q1 q2 q3 q4,i(var) j(stat) string

order var stat

sa "$P/Elas_CIapprox.dta",replace

u "$P/elas_results1.dta",clear

append using "$P/Elas_CIcubic.dta"
append using "$P/Elas_CIlinear.dta"
append using "$P/Elas_CIpref.dta"
append using "$P/Elas_CIapprox.dta"

foreach v in mean q1 q2 q3 q4 {
    gen `v'out=round(`v',0.01)
    format `v'out %4.2f
    }

drop mean q1 q2 q3 q4

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide meanout q1out q2out q3out q4out, i(var) j(stat)

foreach v in mean q1 q2 q3 q4 {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep var meanout2 q1out2 q2out2 q3out2 q4out2 CImean CIq1 CIq2 CIq3 CIq4

**Table 4.4
foreach x of numlist 1 2 3  {
    local vrname  :   label  (var)   `x'
    if `x'==1 listtab meanout2 q1out2 q2out2 q3out2 q4out2 using "$G/Elas_T1.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>1  listtab meanout2 q1out2 q2out2 q3out2 q4out2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$G/Elas_T1.tex" )
    if `x'==1|`x'==2|`x'==3 listtab CImean CIq1 CIq2 CIq3 CIq4 in `x' ,   rstyle(tabular)  appendto("$G/Elas_T1.tex")   begin(&)
    }

**Table 4.6
foreach x of numlist 1 4  {
    local vrname  :   label  (var)   `x'
    if `x'==1 listtab meanout2 q1out2 q2out2 q3out2 q4out2 using "$G/Elas_T2.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>1  listtab meanout2 q1out2 q2out2 q3out2 q4out2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$G/Elas_T2.tex" )
    if `x'==1|`x'==4 listtab CImean CIq1 CIq2 CIq3 CIq4 in `x' ,   rstyle(tabular)  appendto("$G/Elas_T2.tex")   begin(&)
    }
